welcome_text = """
    ***************************************************
    Welcome to the ConceptNet v2 mini-browser!
    (for more info, please visit www.conceptnet.org)
    ***************************************************
    The purpose of this browser is to allow you to
    explore the ConceptNet API interactively!
    Instructions for browsing:
    - First, click on one of the light-green or yellow
    buttons to select a mode of browsing
    - In the red box, enter some input text
        - Light-green buttons signify "node-level" modes,
        so you may only input concepts like "apple" or
        "eat food". You'll notice that the query
        automatically executes when you press the space
        bar or the return key. In this mode, concepts
        must be given in normalized form (verbs in
        infinitive form, no plurals, no "the" or "a")
        - Yellow buttons signify "document-level" modes, so
        you can paste any amount of text into the red
        box (e.g. a sentence to a document) and the text
        doesn't have to be normalized. In this mode, you
        must press the return key to execute your query.
    - Results are displayed in the deep-green box and
    you may have to scroll to see all of the results
    - Most modes are self-explanatory, but for
    additional information, please consult the api's
    html documentation and www.conceptnet.org
    That's all! So enjoy!
"""
from Tkinter import *
import ConceptNetDB,sys
__version__ = "2.0"
__author__ = "hugo@media.mit.edu"
__url__ = 'www.conceptnet.org'
config_filename = 'ConceptNet.ini'
print "Determining which knowledge libraries to load from %s..."%config_filename
c,root,mode_var=ConceptNetDB.ConceptNetDB(None,config_filename),Tk(),StringVar()
root.title("conceptnet 2.0 mini-browser"),root.option_add('*Font',('Courier', 14, 'bold'))
frame1,win2,frame3 = Frame(root),Frame(root,height="1",bg="#CCFF99"),Frame(root)
frame1.pack(fill=BOTH,expand=NO),win2.pack(fill=BOTH,expand=NO),frame3.pack(fill=BOTH,expand=YES)
win,win3,win_scroll,win3_scroll = Text(frame1,bg="#FF3300",fg="white",height="3",wrap=WORD),Text(frame3,wrap=WORD,height="30",width="20",bg="#669933",fg="white"),Scrollbar(frame1),Scrollbar(frame3)
win_scroll.pack(side=RIGHT,fill=Y),win3_scroll.pack(side=RIGHT,fill=Y),win.pack(fill=BOTH,expand=NO),win2.pack(fill=BOTH,expand=NO),win3.pack(fill=BOTH,expand=1)
win.config(yscrollcommand=win_scroll.set),win3.config(yscrollcommand=win3_scroll.set),win_scroll.config(command=win.yview),win3_scroll.config(command=win3.yview)
Radiobutton(win2,text="BROWSE",variable=mode_var,value='browse',fg="#FF3399",bg='#CCFF99',indicatoron=0).pack(side=LEFT),Radiobutton(win2,text="CONTEXT",variable=mode_var,value='context',indicatoron=0,fg="#FF3399",bg='#CCFF99').pack(side=LEFT),Radiobutton(win2,text="PROJECTION",variable=mode_var,value='projection',indicatoron=0,fg="#FF3399",bg='#CCFF99').pack(side=LEFT),Radiobutton(win2,text="ANALOGY",variable=mode_var,value='analogy',indicatoron=0,fg="#FF3399",bg='#CCFF99').pack(side=LEFT),Radiobutton(win2,text="GUESS CONCEPT",variable=mode_var,value='guessconcept',indicatoron=0,fg="#FF3399",bg='#FFFF66').pack(side=LEFT),Radiobutton(win2,text="GUESS TOPIC",variable=mode_var,value='guesstopic',indicatoron=0,fg="#FF3399",bg='#FFFF66').pack(side=LEFT),Radiobutton(win2,text="GUESS MOOD",variable=mode_var,value='guessmood',indicatoron=0,fg="#FF3399",bg='#FFFF66').pack(side=LEFT),Radiobutton(win2,text="SUMMARIZE",variable=mode_var,value='summarize',indicatoron=0,fg="#FF3399",bg='#FFFF66').pack(side=LEFT)
win3.insert(0.0,welcome_text)
execution1=lambda x: (mode_var.get() not in ['guessmood','guesstopic','guessconcept','summarize']) and execution2(x)
execution2=lambda x: (not win3.delete(0.0,END)) and ((win.get(0.0,END).strip()=='' and not win3.insert(0.0,welcome_text)) or (mode_var.get()=='context' and not win3.insert(0.0,'\n'.join(map(lambda z:z[0]+' ('+str(int(z[1]*100))+'%)',c.get_context(map(lambda tok:tok.strip(),win.get(0.0,END).encode('ascii','ignore').split(','))))) +'\n\n')) or (mode_var.get()=='projection' and not win3.insert(0.0,'\n\n'.join(map(lambda v:v[0].upper()+'\n'+'\n'.join(map(lambda z:z[0]+' ('+str(int(z[1]*100))+'%)',v[1])[:10]),c.get_all_projections(map(lambda tok:tok.strip(),win.get(0.0,END).encode('ascii','ignore').split(','))))) +'\n\n')) or (mode_var.get()=='analogy' and not win3.insert(0.0,'\n\n'.join(map(lambda match:'[~'+match[0]+'] ('+str(match[2])+')\n  '+'\n  '.join(map(lambda struct:'=='+struct[0]+'==> '+struct[1]+' ('+str(struct[2])+') ',match[1])),c.get_analogous_concepts(win.get(0.0,END).encode('ascii','ignore').strip()))))) or (mode_var.get()=='guessconcept' and not win3.insert(0.0,'\n\n'.join(map(lambda match:'[is it: '+match[0]+'?] ('+str(match[2])+')\n  '+'\n  '.join(map(lambda struct:'=='+struct[0]+'==> '+struct[1]+' ('+str(struct[2])+') ',match[1])),c.nltools.guess_concept(win.get(0.0,END).encode('ascii','ignore').strip()))))) or (mode_var.get()=='guesstopic' and not win3.insert(0.0,'\n'.join(map(lambda z:z[0]+' ('+str(int(z[1]*100))+'%)',c.nltools.guess_topic(win.get(0.0,END).encode('ascii','ignore').strip())[1])) +'\n\n')) or (mode_var.get()=='guessmood' and not win3.insert(0.0,'\n'.join(map(lambda z:z[0]+' ('+str(int(z[1]*100))+'%)',c.nltools.guess_mood(win.get(0.0,END).encode('ascii','ignore').strip()))) +'\n\n')) or (mode_var.get()=='summarize' and not win3.insert(0.0,c.nltools.summarize_document(win.get(0.0,END).encode('ascii','ignore').strip()) +'\n\n')) or (mode_var.get()=='foo' and 1) or win3.insert(0.0,c.display_node(win.get(0.0,END).encode('ascii','ignore'))+'\n\n'))
win.bind('<space>',execution1),win.bind('<Return>',execution2)
root.mainloop()