import os,re,sys,random,string,time
import montylingua
import RefinePredicates
__version__ = "2.0"
__author__ = "hugo@media.mit.edu"
__url__ = 'www.conceptnet.org'
class GeneralisePredicates:


    preds_file = './refined_predicates.txt'
    generalised_preds_file = './generalised_predicates.txt'
    lifted_preds_file = './lifted_class_predicates.txt'
    pred_args = {}
    lookup = {}
    def __init__(self):

        self.theRefinePredicates = RefinePredicates.RefinePredicates()
        self.theMontyLingua = self.theRefinePredicates.theMontyLingua
        self.load_preds()
    def pp_augmented_predicate(self,pred):

        linktype = pred[0]
        args = pred[1:3]
        count = pred[3]
        inferred_count = pred[4]
        return '('+linktype+' '+' '.join(map(lambda x:'"'+x+'"',args))+' "f='+str(count)+';'+'i='+str(inferred_count)+';")'
    def load_preds(self):

        pred_args = self.pred_args
        unpp_predicate = self.unpp_predicate
        f=open(self.preds_file,'r')
        lines = f.read().split('\n')
        f.close()
        lines = filter(lambda x:x.strip()!='',lines)
        for i in range(len(lines)):
            predicate = tuple(unpp_predicate(lines[i]))
            old = pred_args.get(predicate,[0,0])
            pred_args[predicate]=[old[0]+1,old[1]]
        return
    def output_preds(self):

        f=open(self.generalised_preds_file,'w')
        for pred_arg in self.pred_args.keys():
            aug_pred = list(pred_arg)+self.pred_args[pred_arg]
            output_line = self.pp_augmented_predicate(aug_pred)+'\n'
            f.write(output_line)
        f.close()
        return
    def infer_over_all_pred_args(self):

        pred_args = self.pred_args
        predicate_variations = self.predicate_variations
        refine_predicate = self.theRefinePredicates.refine_predicate
        key_count = len(pred_args.keys())
        progress_count = 0
        for key in pred_args.keys():
            progress_count +=1
            if progress_count % 1000 == 0:
                print "\n\n\n\n\ninferring from",progress_count,"out of",key_count,"predicates"
            count,inferred_count = pred_args[key]
            if count>0:
                variations = predicate_variations(key)
                if variations:
                    print key,'\nvaries as:','\n  '.join(map(lambda x:str(x),variations))
                for variation in variations:
                    variation = refine_predicate(variation)
                    if not variation:
                        continue
                    old = pred_args.get(variation,[0,0])
                    new = [old[0],old[1]+1]
                    pred_args[variation]=new
        return
    def extract_capableofreceivingaction(self):

        pred_args = self.pred_args
        list_chunks = self.theMontyLingua.theMontyChunker.list_chunks
        strip_tags = self.theMontyLingua.strip_tags
        refine_predicate = self.theRefinePredicates.refine_predicate
        for predicate in pred_args.keys():
            pred,arg1,arg2 = predicate
            arg_chunked = self.postchunk_px(self.chunk(arg2))
            chunks = list_chunks(arg_chunked)
            if len(chunks)<2 or chunks[0][1].lower()!='vx' or chunks[1][1].lower()!='nx':
                continue
            verb = strip_tags(chunks[0][0])
            semantically_ambiguous = ['have','be','get','achieve','act','allow','appear','become','come','could','do','feel','go','give','know','lay','leave','let','make','may','mean','meet','might','must','ought','put','provide','set','shall','should','show','take','tell','think','will','would','use']
            semantically_ambiguous = semantically_ambiguous + map(lambda x:'not '+x,semantically_ambiguous)
            semantically_ambiguous = semantically_ambiguous + map(lambda x:'do '+x,semantically_ambiguous)
            if verb in semantically_ambiguous:
                continue
            np = ' '.join(filter(lambda x:x.split('/')[1] not in ['JJ','JJR','JJS','CD'],chunks[1][0].split()))
            np = strip_tags(np)
            new_predicate = ('CapableOfReceivingAction',np,verb)
            new_predicate = refine_predicate(new_predicate)
            if not new_predicate:
                continue
            old = pred_args.get(new_predicate,[0,0])
            new = [old[0],old[1]+1]
            self.pred_args[new_predicate]=new
        return
    def extract_properties(self):

        pred_args = self.pred_args
        postchunk_px = self.postchunk_px
        self_chunk = self.chunk
        list_chunks = self.theMontyLingua.theMontyChunker.list_chunks
        strip_tags = self.theMontyLingua.strip_tags
        refine_predicate = self.theRefinePredicates.refine_predicate
        for predicate in self.pred_args.keys():
            pred,arg1,arg2 = predicate
            if pred != 'IsA':
                continue
            arg_chunked = postchunk_px(self_chunk(arg2))
            chunks = list_chunks(arg_chunked)
            if len(chunks)<1:
                continue
            chunk = chunks[0][0]
            adjs = []
            for tok in chunk.split():
                if tok.split('/')[1] == 'JJ':
                    adjs.append(tok.split('/')[0])
            new_predicates = map(lambda x:('PropertyOf',arg1,x),adjs)
            for new_predicate in new_predicates:
                new_predicate = refine_predicate(new_predicate)
                if not new_predicate:
                    continue
                old = pred_args.get(new_predicate,[0,0])
                new = [old[0],old[1]+1]
                pred_args[new_predicate]=new
        return
    def generalise_to_classes(self):

        pred_args = self.pred_args
        refine_predicate = self.theRefinePredicates.refine_predicate
        class_nodes = {}


        lifted_characteristics = []
        for key in pred_args.keys():
            pred,arg1,arg2 = key
            if pred != 'IsA':
                continue
            class_nodes[arg2] = class_nodes.get(arg2,[])+[arg1]


        for key in class_nodes.keys():
            if len(class_nodes[key])<3:
                del class_nodes[key]
        print len(class_nodes.keys()), "classes"
        for key in class_nodes.keys():
            children = class_nodes[key]
            child_count = len(children)
            shared_structures = {}
            for x in pred_args.keys():
                if x[1] not in children or x[0]=='IsA':
                    continue
                shared_structures[(x[0],x[2])] = shared_structures.get((x[0],x[2]),0)+1
            for shared_structure in shared_structures.keys():
                votes = shared_structures[shared_structure]
                if votes*1./child_count < 0.5:
                    del shared_structures[shared_structure]
            lifted = map(lambda x:(x[0],key,x[1]),shared_structures.keys())
            print "LIFTED: ",lifted
            lifted_characteristics += lifted
        for variation in lifted_characteristics:
            variation = refine_predicate(variation)
            if not variation:
                continue
            old = pred_args.get(variation,[0,0])
            new = [old[0],old[1]+2]
            pred_args[variation]=new
        f=open(self.lifted_preds_file,'w')
        f.write('\n'.join(map(lambda x:str(x),lifted_characteristics)))
        f.close()
        return
    def predicate_variations(self,predicate):

        pred,arg1,arg2 = predicate
        arg2_variants = self.arg_variations(arg2)
        return reduce(lambda a,b:a+b,[[(pred,arg1,x),('SuperThematicKLine',arg2,x)] for x in arg2_variants],[])
    def arg_variations(self,arg):

        arg_chunked = self.postchunk_px(self.chunk(arg))
        chunks = self.theMontyLingua.theMontyChunker.list_chunks(arg_chunked)
        variations = []
        for i in map(lambda x:x+1,range(len(chunks))):
            if i==0:
                continue
            flattened = reduce(lambda a,b:a+' '+b,map(lambda x:x[0],chunks[:i]))
            variation = self.theMontyLingua.strip_tags(flattened)
            if variation not in variations:
                variations.append(variation)
            flattened_toks = flattened.split()
            for j in map(lambda x:x+1,range(len(flattened_toks))):
                flattened_no_modifiers = ' '.join(filter(lambda x:tuple(x.split('/')[1:2]) not in [('JJ',),('JJR',),('JJS',),('CD',)],flattened_toks[:j])+flattened_toks[j:])
                variation_no_modifiers = self.theMontyLingua.strip_tags(flattened_no_modifiers)
                if variation_no_modifiers not in variations:
                    variations.append(variation_no_modifiers)
        semantically_ambiguous = ['have','be','get','achieve','act','allow','appear','become','come','could','do','feel','go','give','know','lay','leave','let','make','may','mean','meet','might','must','ought','put','provide','set','shall','should','show','take','tell','think','will','would','use']
        semantically_ambiguous = semantically_ambiguous + map(lambda x:'not '+x,semantically_ambiguous)
        semantically_ambiguous = semantically_ambiguous + map(lambda x:'do '+x,semantically_ambiguous)
        return filter(lambda x:x not in [arg,'']+semantically_ambiguous,variations)
    def apply_swaplist(self,text):

        text = ' '+text+' '
        self.swaplist.sort()
        for swapper in self.swaplist:
            trigger,conseq = swapper
            text =text.replace(' '+trigger+' ',' '+conseq+' ')
        return text.strip()
    def repair_arg(self,arg_chunked,re_pattern):

        return arg_chunked
    def arg_grammar_accept_p(self,arg_chunked,re_pattern):

        toks = arg_chunked.split()
        for i in range(len(toks)):
            if '/' not in toks[i]:
                toks[i] = '/'+toks[i]
        tags = map(lambda x:x.split('/')[1],toks)
        processed_tags_str = ' '+' '.join(tags)+' '
        collapse_re = " \((.X) .+? (.X)\) "
        collapse_re = re.compile(collapse_re)
        dirtyBit = 1
        while dirtyBit:
            dirtyBit = 0
            m = collapse_re.search(processed_tags_str)
            if m:
                dirtyBit = 1
                chunk_type = m.groups()[0]
                processed_tags_str = processed_tags_str[:m.start()]+' '+chunk_type+' '+processed_tags_str[m.end():]
        arg_pattern = ' '+' '.join(processed_tags_str.split())+' '
        m = re.search(re_pattern,arg_pattern)
        if m:
            return 1
        else:
            return 0
    def postchunk_px(self,chunked):

        lookup = self.lookup
        toks = chunked.split()
        for i in range(len(toks)):
            if '/' not in toks[i]:
                toks[i] = '/'+toks[i]
        pairs = map(lambda x:x.split('/'),toks)
        words = map(lambda x:x[0],pairs)
        tags = map(lambda x:x[1],pairs)
        pc_re = " (IN )?IN \(NX(.+?) NX\) "
        pc_re = re.compile(pc_re)
        dirtyBit = 1
        while dirtyBit:
            dirtyBit = 0
            processed_tags_str = ' '+' '.join(tags)+' '
            m = pc_re.search(processed_tags_str)
            if m:
                dirtyBit = 1
                how_many_toks_on_the_left = len(processed_tags_str[:m.start()].split())
                how_many_toks_on_the_right = len(processed_tags_str[m.end():].split())
                toks_range = (how_many_toks_on_the_left,len(tags)-how_many_toks_on_the_right)
                chunk_words = words[toks_range[0]:toks_range[1]]
                chunk_tags = tags[toks_range[0]:toks_range[1]]
                chunk = ' '.join(map(lambda x:chunk_words[x]+'/'+chunk_tags[x],range(len(chunk_words))))
                nonce = 'PC_'+str(random.randint(0,1000000000))
                cleaned_chunk = ' '.join(filter(lambda x:x not in ['/(NX','/NX)'],chunk.split()))
                lookup[nonce] = cleaned_chunk
                for i in range(len(words)):
                    if i in range(toks_range[0],toks_range[1]):
                        words[i] = 'bar'
                        tags[i] = nonce
        chunked = ' '.join(map(lambda x:words[x]+'/'+tags[x],range(len(words))))
        chunked_toks = chunked.split()
        output_str = ''
        seen_nounces = []
        for tok in chunked_toks:
            word,pos = tok.split('/')
            if pos in seen_nounces:
                continue
            elif len(pos)>=4 and pos[:len('PC_')] in ['PC_']:
                seen_nounces.append(pos)
                chunk_type = pos[:len('P')]+'X'
                output_str+=' ('+chunk_type+' '+lookup.get(pos,'')+' '+chunk_type+') '
            else:
                output_str+=' '+tok+ ' '
        output_str = output_str.replace(' /(NX ',' (NX ')
        output_str = output_str.replace(' /NX) ',' NX) ')
        output_str = output_str.replace(' /(VX ',' (VX ')
        output_str = output_str.replace(' /VX) ',' VX) ')
        output_str = output_str.replace(' /(AX ',' (AX ')
        output_str = output_str.replace(' /AX) ',' AX) ')
        output_str = output_str.replace(' /(PX ',' (PX ')
        output_str = output_str.replace(' /PX) ',' PX) ')
        output_str = ' '.join(output_str.split())
        return output_str
    def constrain_chunktype(self,text,chunktype):

        chunked = self.chunk(text)
        if chunktype in ['AX','NX']:
            chunked_toks = chunked.split()
            if len(chunked_toks)>2 and chunked_toks[0]=='('+chunktype and chunked_toks[-1]==chunktype+')':
                return 1
            else:
                return 0
        elif chunktype in ['VP','VP_noncopula','VP_copula']:
            chunked_toks = chunked.split()
            if len(chunked_toks)>2 and chunked_toks[0]=='(VX' and chunked_toks[-1] in ['VX)','NX)']:
                if chunktype == 'VP':
                    return 1
                elif chunktype == 'VP_noncopula':
                    if len(chunked_toks[1].split('/'))==2 and chunked_toks[1].split('/')[0].lower() not in ['is','be','being','been','are','were','was','am']:
                        return 1
                    else:
                        return 0
                elif chunktype == 'VP_copula':
                    if len(chunked_toks[1].split('/'))==2 and chunked_toks[1].split('/')[0].lower() in ['is','be','being','been','are','were','was','am']:
                        return 1
                    else:
                        return 0
        elif chunktype == 'PX':
            if len(chunked_toks)>3:
                m = re.search('^(IN |TO ){1,2}\(NX (.+) NX\)$',chunked)
                if m:
                    return 1
            else:
                return 0
        return 0
    def constrain_pos(self,text,pos_regexp):

        tagged = self.tag(text)
        tags = ' '.join(map(lambda x:x.split('/')[1],tagged.split()))
        cre = re.compile(pos_regexp)
        m = cre.search(tags)
        if m:
            return 1
        return 0
    def lemmatise(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        lemmatised_text = self.theMontyLingua.lemmatise_tagged(tagged_text)
        return ' '.join(map(lambda x:x.split('/')[2],lemmatised_text.split()))
    def chunk_and_lemmatise(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        lemmatised_text = self.theMontyLingua.lemmatise_tagged(tagged_text)
        chunked = self.theMontyLingua.chunk_lemmatised(lemmatised_text)
        return chunked
    def chunk(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        chunked = self.theMontyLingua.chunk_tagged(tagged_text)
        return chunked
    def tag(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        return tagged_text
    def unpp_predicate(self,pp_pred):

        pp_pred = pp_pred.strip()[1:-1]
        pp_pred = pp_pred.split()
        pred = pp_pred[0]
        pp_pred = ' '.join(pp_pred[1:])
        args = pp_pred[1:-1].split('" "')
        return [pred]+args
if __name__ == '__main__':
    r = GeneralisePredicates()
    r.extract_properties()
    r.extract_capableofreceivingaction()
    r.infer_over_all_pred_args()
    r.generalise_to_classes()
    r.output_preds()