import os,re,sys,random,string,time
import montylingua
__version__ = "2.0"
__author__ = "hugo@media.mit.edu"
__url__ = 'www.conceptnet.org'
class RefinePredicates:


    preds_file = './generated_predicates.txt'
    refined_preds_file = './refined_predicates.txt'
    pred_args = []
    lookup = {}
    re_grammar = {
        'IsA':['^ NX $','^ NX (PX )*$'],
        'default':['^ (VX )*(AX )*(NX )*(PX )*$','^ (VX )*(AX )*(NX )*(PX )*$'],
        }
    swaplist = [
        ['people \'s','person \'s'],
        ['people','person'],
        ['someone \'s','person \'s'],
        ['someone','person'],
        ['anyone \'s','person \'s'],
        ['anyone','person'],
        ['everyone \'s','person \'s'],
        ['everyone','person'],
        ['my','person \'s'],
        ['me','person'],
        ['i','person'],
        ['your','person \'s'],
        ['you','person'],
        ['their','person \'s'],
        ['them','person'],
        ['they','person'],
        ['his','person \'s'],
        ['he','person'],
        ['her','person \'s'],
        ['she','person'],
        ]
    graylist = ['there','it','i','that','they','we','them','one','what','who','fact','1','him','her','us','yourself','thing','part','piece','be','first','second','third','i\'m','concept','situation','event','question','answer','statement','story','step','time','consequence','0','2','3','4','5','6','word','something','someone','something','effect','activity','event','kind','one way','man','woman','other','common sense','ourselves','themselves','himself','herself','symbol','I','human','nothing','bob','john','mary','two','three','four','five','reason','purpose','everything','anything','need','life','u','lot','property','way']
    blacklist = ['there','it','i','I','that','they','we','them','one','what','who','fact','0','1','2','3','4','5','6','him','her','us','yourself','thing','part','piece','be','have','not be','not have','want','not want','i\'m','get']
    blacklist += list(string.lowercase)+list(string.digits)
    male_fnames = ['Hugo','Push','Marvin','Nick','James','Jim','John','Johnny','Robert','Bob','Michael','Mike','William','Bill','Billy','David','Dave','Richard','Dick','Charles','Charlie','Joseph','Joe','Joey','Thomas','Tom','Tommy','Christopher','Chris','Daniel','Dan','Paul','Mark','Donald','Don','George','Kenneth','Ken','Steven','Stephen','Steve','Edward','Eddie','Ed','Brian','Ronald','Ron','Anthony','Tony','Kevin','Jason','Matthew','Matt','Gary','Timothy','Tim','Jose','Larry','Jeffrey','Jeff','Frank','Fred','Scott','Eric','Stephen','Andrew','Andy','Raymond','Ray','Gregory','Greg','Gregg','Joshua','Josh','Jerry','Dennis','Walter','Patrick','Pat','Peter','Harold','Harry','Douglas','Henry','Carl','Arthur','Ryan','Roger','Sam','Dwight','Melvin','Juan']
    female_fnames = ['Briana','Lea','Eileen','Belinda','Juanita','Julie','Sally','Cindy','Jane','Joyce','Judy','Alyssa','Mary','Patricia','Patty','Linda','Barbara','Elizabeth','Jennifer','Maria','Susan','Margaret','Dorothy','Lisa','Nancy','Karen','Betty','Helen','Sandra','Donna','Carol','Ruth','Sharon','Michelle','Laura','Laurie','Sarah','Sara','Kimberly','Kim','Deborah','Jesse','Jessica','Shirley','Cynthia','Angela','Angie','Melissa','Brenda','Amy','Anna','Rebecca','Becky','Virginia','Kathleen','Kathy','Pamela','Martha','Debra','Amanda','Stephanie','Carolyn','Carol','Christine','Marie','Janet','Catherine','Cathy','Frances','Ann','Annie','Diane','Diana','Dianna']
    blacklist += map(lambda x:x.lower(),male_fnames+female_fnames)
    def __init__(self):

        self.theMontyLingua = montylingua.MontyLingua.MontyLingua()
        self.load_preds()
    def load_preds(self):

        f=open(self.preds_file,'r')
        lines = f.read().split('\n')
        f.close()
        lines = filter(lambda x:x.strip()!='',lines)
        for i in range(len(lines)):
            self.pred_args.append(self.unpp_predicate(lines[i]))
        return
    def refine_all_preds(self):

        f=open(self.refined_preds_file,'w')
        for pred_arg in self.pred_args:
            refined = self.refine_predicate(pred_arg)
            if refined:
                output_line = self.pp_predicate(refined)+'\n'
                f.write(output_line)
        f.close()
        return
    def refine_predicate(self,predicate):

	graylist = self.graylist
	blacklist = self.blacklist
        pred,arg1,arg2 = predicate
        res1 = self.refine_arg(arg1,self.re_grammar.get(pred,self.re_grammar['default'])[0])
        res2 = self.refine_arg(arg2,self.re_grammar.get(pred,self.re_grammar['default'])[1])
        if not res1 or not res2:
            return None
	if pred =='ConceptuallyRelatedTo' and (res1.lower() in graylist+blacklist or res2.lower() in graylist+blacklist):
            return None
        elif res1.lower() in blacklist or res2.lower() in blacklist:
            return None
        return (pred,res1,res2)
    def refine_arg(self,arg,re_pattern):

        arg_chunked = self.postchunk_px(self.chunk(arg))
        res = self.arg_grammar_accept_p(arg_chunked,re_pattern)
        if not res:
            arg_chunked = self.repair_arg(arg_chunked,re_pattern)
            res = self.arg_grammar_accept_p(arg_chunked,re_pattern)
            if not res:
                return None
        toks = arg_chunked.split()
        for i in range(len(toks)):
            if '/' not in toks[i]:
                toks[i] = '/'+toks[i]
        stop_pos = ['DT','MD',',','.']
        for i in range(len(toks)):
            word,pos = toks[i].split('/')
            if pos in stop_pos:
                toks[i]=''
                continue
            elif pos=='RB' and word.lower()!='not':
                toks[i]=''
                continue
        normalized = (' '.join(toks)).lower()
        normalized = ' '.join(filter(lambda y:y!='',map(lambda x: x.split('/')[0],normalized.split())))
        normalized = self.lemmatise(normalized)
        normalized = self.apply_swaplist(normalized)
        return normalized
    def apply_swaplist(self,text):

        text = ' '+text+' '
        self.swaplist.sort()
        for swapper in self.swaplist:
            trigger,conseq = swapper
            text =text.replace(' '+trigger+' ',' '+conseq+' ')
        return text.strip()
    def repair_arg(self,arg_chunked,re_pattern):

        return arg_chunked
    def arg_grammar_accept_p(self,arg_chunked,re_pattern):

        toks = arg_chunked.split()
        for i in range(len(toks)):
            if '/' not in toks[i]:
                toks[i] = '/'+toks[i]
        tags = map(lambda x:x.split('/')[1],toks)
        processed_tags_str = ' '+' '.join(tags)+' '
        collapse_re = " \((.X) .+? (.X)\) "
        collapse_re = re.compile(collapse_re)
        dirtyBit = 1
        while dirtyBit:
            dirtyBit = 0
            m = collapse_re.search(processed_tags_str)
            if m:
                dirtyBit = 1
                chunk_type = m.groups()[0]
                processed_tags_str = processed_tags_str[:m.start()]+' '+chunk_type+' '+processed_tags_str[m.end():]
        arg_pattern = ' '+' '.join(processed_tags_str.split())+' '
        m = re.search(re_pattern,arg_pattern)
        if m:
            return 1
        else:
            return 0
    def postchunk_px(self,chunked):

        toks = chunked.split()
        for i in range(len(toks)):
            if '/' not in toks[i]:
                toks[i] = '/'+toks[i]
        pairs = map(lambda x:x.split('/'),toks)
        words = map(lambda x:x[0],pairs)
        tags = map(lambda x:x[1],pairs)
        pc_re = " (IN )?IN \(NX(.+?) NX\) "
        pc_re = re.compile(pc_re)
        dirtyBit = 1
        while dirtyBit:
            dirtyBit = 0
            processed_tags_str = ' '+' '.join(tags)+' '
            m = pc_re.search(processed_tags_str)
            if m:
                dirtyBit = 1
                how_many_toks_on_the_left = len(processed_tags_str[:m.start()].split())
                how_many_toks_on_the_right = len(processed_tags_str[m.end():].split())
                toks_range = (how_many_toks_on_the_left,len(tags)-how_many_toks_on_the_right)
                chunk_words = words[toks_range[0]:toks_range[1]]
                chunk_tags = tags[toks_range[0]:toks_range[1]]
                chunk = ' '.join(map(lambda x:chunk_words[x]+'/'+chunk_tags[x],range(len(chunk_words))))
                nonce = 'PC_'+str(random.randint(0,1000000000))
                cleaned_chunk = ' '.join(filter(lambda x:x not in ['/(NX','/NX)'],chunk.split()))
                self.lookup[nonce] = cleaned_chunk
                print nonce,'<-',cleaned_chunk
                for i in range(len(words)):
                    if i in range(toks_range[0],toks_range[1]):
                        words[i] = 'bar'
                        tags[i] = nonce
        chunked = ' '.join(map(lambda x:words[x]+'/'+tags[x],range(len(words))))
        chunked_toks = chunked.split()
        output_str = ''
        seen_nounces = []
        for tok in chunked_toks:
            word,pos = tok.split('/')
            if pos in seen_nounces:
                continue
            elif len(pos)>=4 and pos[:len('PC_')] in ['PC_']:
                seen_nounces.append(pos)
                chunk_type = pos[:len('P')]+'X'
                output_str+=' ('+chunk_type+' '+self.lookup.get(pos,'')+' '+chunk_type+') '
            else:
                output_str+=' '+tok+ ' '
        output_str = output_str.replace(' /(NX ',' (NX ')
        output_str = output_str.replace(' /NX) ',' NX) ')
        output_str = ' '.join(output_str.split())
        return output_str
    def constrain_chunktype(self,text,chunktype):

        chunked = self.chunk(text)
        if chunktype in ['AX','NX']:
            chunked_toks = chunked.split()
            if len(chunked_toks)>2 and chunked_toks[0]=='('+chunktype and chunked_toks[-1]==chunktype+')':
                return 1
            else:
                return 0
        elif chunktype in ['VP','VP_noncopula','VP_copula']:
            chunked_toks = chunked.split()
            if len(chunked_toks)>2 and chunked_toks[0]=='(VX' and chunked_toks[-1] in ['VX)','NX)']:
                if chunktype == 'VP':
                    return 1
                elif chunktype == 'VP_noncopula':
                    if len(chunked_toks[1].split('/'))==2 and chunked_toks[1].split('/')[0].lower() not in ['is','be','being','been','are','were','was','am']:
                        return 1
                    else:
                        return 0
                elif chunktype == 'VP_copula':
                    if len(chunked_toks[1].split('/'))==2 and chunked_toks[1].split('/')[0].lower() in ['is','be','being','been','are','were','was','am']:
                        return 1
                    else:
                        return 0
        elif chunktype == 'PX':
            if len(chunked_toks)>3:
                m = re.search('^(IN |TO ){1,2}\(NX (.+) NX\)$',chunked)
                if m:
                    return 1
            else:
                return 0
        return 0
    def constrain_pos(self,text,pos_regexp):

        tagged = self.tag(text)
        tags = ' '.join(map(lambda x:x.split('/')[1],tagged.split()))
        cre = re.compile(pos_regexp)
        m = cre.search(tags)
        if m:
            return 1
        return 0
    def lemmatise(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        lemmatised_text = self.theMontyLingua.lemmatise_tagged(tagged_text)
        return ' '.join(map(lambda x:x.split('/')[2],lemmatised_text.split()))
    def chunk_and_lemmatise(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        lemmatised_text = self.theMontyLingua.lemmatise_tagged(tagged_text)
        chunked = self.theMontyLingua.chunk_lemmatised(lemmatised_text)
        return chunked
    def chunk(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        chunked = self.theMontyLingua.chunk_tagged(tagged_text)
        return chunked
    def tag(self,text):

        toked_text = self.theMontyLingua.tokenize(text)
        tagged_text = self.theMontyLingua.tag_tokenized(toked_text)
        return tagged_text
    def pp_predicate(self,pred):

        linktype = pred[0]
        args = pred[1:]
        return '('+linktype+' '+' '.join(map(lambda x:'"'+x+'"',args))+')'
    def unpp_predicate(self,pp_pred):

        pp_pred = pp_pred.strip()[1:-1]
        pp_pred = pp_pred.split()
        pred = pp_pred[0]
        pp_pred = ' '.join(pp_pred[1:])
        args = pp_pred[1:-1].split('" "')
        return [pred]+args
if __name__ == '__main__':
    r = RefinePredicates()
    r.refine_all_preds()